<script setup lang="ts">
import { ref, computed, watch, inject, PropType, defineProps } from 'vue';
import {
  JText,
  JContainer,
  JAppLogo,
  JFormControl,
  JTextField,
  JErrorMessages,
  JButton,
} from '@new-jira-clone/ui/src/components';
import { useVuelidate } from '@vuelidate/core';
import { email } from '@vuelidate/validators';
import { i18n } from '@new-jira-clone/libs/src/types';
import { minLength, required, getError } from '@/shared/utils';
import { type RegistrationForm } from '@/shared/api';
import { SuggestionToAuthLink } from '@/shared/ui';
import { pathConfig } from '@/shared';

const props = defineProps({
  submitForm: {
    type: Function as PropType<(form: RegistrationForm) => Promise<void>>,
    required: true,
  },
});

const $t = inject('$t') as i18n;

const registrationForm = ref<RegistrationForm>({
  name: '',
  email: '',
  password: '',
});

const rules = computed(() => ({
  name: {
    required,
    minLength: minLength(4),
  },
  email: {
    required,
    email,
    minLength: minLength(4),
  },
  password: {
    required,
    minLength: minLength(4),
  },
}));

const v$ = useVuelidate(rules, registrationForm.value);

const errorsMessages = ref<string[]>([]);

const resetFormErrorsMessages = () => {
  errorsMessages.value = [];
};

const isSubmitForm = ref(false);

const submitForm = async () => {
  if (isSubmitForm.value) return;

  const isValidForm = await v$.value.$validate();

  if (isValidForm === false) return;

  try {
    isSubmitForm.value = true;
    await props.submitForm(registrationForm.value);
  } catch (error) {
    errorsMessages.value = [String($t('response_form_error'))];
  } finally {
    isSubmitForm.value = false;
  }
};

const getNameErros = computed(() => getError(v$.value.name));
const getEmailErrors = computed(() => getError(v$.value.email));
const getPasswordErrors = computed(() => getError(v$.value.password));

watch(v$, resetFormErrorsMessages);
</script>

<template>
  <JContainer class="login-form">
    <JAppLogo />

    <JText
      tag="h1"
      color="text"
      weight="normal"
      type="title-1"
      class="text-center"
    >
      {{ $t('registration') }}
    </JText>
    <JText
      tag="p"
      type="text1"
      color="text"
      class="text-center mb-4"
    >
      {{ $t('fill_info_message') }} <br />
      {{ $t('fill_info_message_2') }}
    </JText>

    <form @submit.prevent="submitForm">
      <JFormControl>
        <template #label> {{ $t('name') }} </template>
        <JTextField
          v-model="registrationForm.name"
          dense
          name="name"
          text-margin
          outlined
          :close-icon="false"
          @blur="v$.name.$touch()"
        >
          <template #info>
            <JErrorMessages
              data-test-name-error
              :error-messages="getNameErros"
            />
          </template>
        </JTextField>
      </JFormControl>

      <JFormControl>
        <template #label> {{ $t('email') }} </template>
        <JTextField
          v-model="registrationForm.email"
          dense
          name="email"
          type="email"
          text-margin
          outlined
          :close-icon="false"
          @blur="v$.email.$touch()"
        >
          <template #info>
            <JErrorMessages
              data-test-email-error
              :error-messages="getEmailErrors"
            />
          </template>
        </JTextField>
      </JFormControl>

      <JFormControl>
        <template #label> {{ $t('password') }} </template>
        <JTextField
          v-model="registrationForm.password"
          dense
          name="password"
          text-margin
          type="password"
          outlined
          :close-icon="false"
          @blur="v$.password.$touch()"
        >
          <template #info>
            <JErrorMessages
              data-test-password-error
              :error-messages="getPasswordErrors"
            />
          </template>
        </JTextField>
      </JFormControl>

      <JErrorMessages
        data-test-response-errors
        :error-messages="errorsMessages"
      />

      <JButton
        :loading="isSubmitForm"
        size="xs"
        class="submit-form"
      >
        {{ $t('sign_up') }}
      </JButton>

      <SuggestionToAuthLink :to="pathConfig.login">
        {{ $t('account_exist') }}
      </SuggestionToAuthLink>
    </form>
  </JContainer>
</template>

<style lang="scss" scoped>
.submit-form {
  margin-top: 24px;
  width: 100%;
}
</style>
